#USB_PID=$F4EF  ; USB  
#USB_VID=$AB80

Enumeration
  #Window_0
  #Text_0
  #Text_1
  #Button_0
  #Button_1
EndEnumeration

Global R_Handle, W_Handle ;  

If OpenLibrary(1,"HID_Lib_Plus_x64.dll")=0 ;  
 MessageRequester("", "  "+Chr(34)+"HID_Lib_Plus_x64.dll"+Chr(34), 16)
 End  ;   
EndIf

;     HID_Lib_Plus
Prototype HID_DeviceTest(PID.w, VID.w, Number.w, Index.w)
 Global HID_DeviceTest.HID_DeviceTest=GetFunction(1,"HID_DeviceTest")
Prototype HID_OpenDevice(PID.w, VID.w, Number.w, Index.w)
 Global HID_OpenDevice.HID_OpenDevice=GetFunction(1,"HID_OpenDevice")
Prototype HID_ReadDevice(Handle, *Buffer, LenBuf)
 Global HID_ReadDevice.HID_ReadDevice=GetFunction(1,"HID_ReadDevice")
Prototype HID_WriteDevice(Handle, *Buffer, LenBuf)
 Global HID_WriteDevice.HID_WriteDevice=GetFunction(1,"HID_WriteDevice")
Prototype HID_CloseDevice(Handle)
 Global HID_CloseDevice.HID_CloseDevice=GetFunction(1,"HID_CloseDevice")
 
;   
Procedure FindDevice_Timer()
Static Old_Test
Test=HID_DeviceTest(#USB_PID, #USB_VID, 2, 0)
If Test<>Old_Test ;    
 Old_Test=Test 
 If Test          ;  
  HID_CloseDevice(R_Handle) : HID_CloseDevice(W_Handle)
  W_Handle=HID_OpenDevice(#USB_PID, #USB_VID, 2, 0)
  R_Handle=HID_OpenDevice(#USB_PID, #USB_VID, 2, 0)
  SetGadgetText(#Text_0, " ")
  SetGadgetColor(#Text_0, #PB_Gadget_FrontColor, 0)
 Else             ;  
  HID_CloseDevice(R_Handle) : R_Handle=0
  HID_CloseDevice(W_Handle) : W_Handle=0
  SetGadgetText(#Text_0, "  ")
  SetGadgetColor(#Text_0, #PB_Gadget_FrontColor, RGB(255, 0, 0))
  SetGadgetText(#Text_1, " = 0")
 EndIf
EndIf
EndProcedure

;    . 
;      .
Procedure ReadDavice_Thread(*p)
 Dim InBuffer.b(2)
 Repeat
  If R_Handle
   InBuffer(0) = 0 ; ID 
   If HID_ReadDevice(R_Handle, @InBuffer(), 2)
     SetGadgetText(#Text_1, " = "+Str(InBuffer(1)!1))
   EndIf
  EndIf
  Delay(10)
 ForEver
EndProcedure

;   
Procedure SendDevice(Led.b)
 Dim OutBuffer.b(2)
 If W_Handle
   OutBuffer(0) = 0  ; ID 
   OutBuffer(1) = Led
   HID_WriteDevice(W_Handle, @OutBuffer(), 2)
 Else
  MessageRequester("Demo Device","    !",16)
 EndIf
EndProcedure

Flag = #PB_Window_MinimizeGadget|#PB_Window_ScreenCentered|#PB_Window_Invisible
If OpenWindow(#Window_0, 0, 0, 258, 116, "USB Demo device", Flag)
 TextGadget(#Text_0, 5, 10, 250, 15, "  ", #PB_Text_Center)
   SetGadgetColor(#Text_0, #PB_Gadget_FrontColor, RGB(255, 0, 0))
 TextGadget(#Text_1, 150, 60, 95, 15, " = 0", #PB_Text_Center)
 ButtonGadget(#Button_0, 5, 35, 120, 28, " ")
 ButtonGadget(#Button_1, 5, 75, 120, 28, " ")
EndIf

FindDevice_Timer()
HideWindow(#Window_0, 0)
AddWindowTimer(#Window_0, 1, 400) ;  .
CreateThread(@ReadDavice_Thread(), 0) ;     .

Repeat
 Event=WaitWindowEvent()
 If Event=#PB_Event_Timer ;   
     If EventTimer()=1    ;   ID 1
       FindDevice_Timer() ;   
     EndIf
 ElseIf Event=#PB_Event_Gadget ;   
   Gadget=EventGadget()
   If Gadget = #Button_0 Or Gadget = #Button_1 ;   
     SendDevice(Gadget - #Button_1)
   EndIf
 EndIf
Until Event=#PB_Event_CloseWindow ;     
; IDE Options = PureBasic 4.40 (Windows - x64)
; CursorPosition = 14
; Folding = -
; EnableThread
; EnableXP
; UseIcon = icon.ico
; Executable = Demo_Device.exe