unit Unit1;

interface



uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
  
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Timer1: TTimer;
    Label2: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
   
  private
    { Private declarations }
  public
    { Public declarations }
      Old_Timer1_Test : integer;
      W_Handle : integer;
  end;
  
type
TNewThread = class(tthread)

private
 InInfo: byte;
 procedure OutInfo;
protected
 procedure Execute; override;
end;


var
  Form1: TForm1;
  function HID_DeviceTest(PID, VID, Number, Index: word): integer; stdcall; external 'HID_Lib_Plus.dll';
  function HID_OpenDevice(PID, VID, Number, Index: word): integer; stdcall; external 'HID_Lib_Plus.dll';
  function HID_ReadDevice(Handle: integer; Buffer: pointer; LenBuf: integer): integer; stdcall; external 'HID_Lib_Plus.dll';
  function HID_WriteDevice(Handle: integer; Buffer: pointer; LenBuf: integer): integer; stdcall; external 'HID_Lib_Plus.dll';
  function HID_CloseDevice(Handle: integer): integer; stdcall; external 'HID_Lib_Plus.dll';

implementation

{$R *.dfm}

procedure TNewThread.Execute;
var
   R_Handle : integer;
   InBuffer : array [0..1] of byte;
   x : byte;
   Test, OldTest : integer;
begin
 x:=0;
 repeat

   Test:=HID_DeviceTest(62703, 43904, 2, 0) ;
   if Test <> OldTest then begin
     OldTest:=Test;
     if Test = 1 then begin
       R_Handle := HID_OpenDevice(62703, 43904, 2, 0) ;
     end else begin
       HID_CloseDevice(R_Handle);
       R_Handle := 0 ;
     end;
   end;

   if R_Handle<>0 then begin
     InBuffer[0]:=0 ;
     if HID_ReadDevice(R_Handle, @InBuffer, 2)>0 then begin
       InInfo := (not InBuffer[1]) and 1;
       Synchronize(OutInfo);
     end;
   end;

  sleep(20);
  until x=1
end;

procedure TNewThread.OutInfo;
begin
  Form1.label2.Caption := ' = '+IntToStr(InInfo);
end;


procedure TForm1.Button1Click(Sender: TObject);
var
  OutBuffer : array [0..1] of byte;
begin
   if W_Handle<>0 then begin
       OutBuffer[0] := 0;
       OutBuffer[1] := 1;
       HID_WriteDevice(W_Handle, @OutBuffer, 2)
   end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  OutBuffer : array [0..1] of byte;
begin
   if W_Handle<>0 then begin
       OutBuffer[0] := 0;
       OutBuffer[1] := 0;
       HID_WriteDevice(W_Handle, @OutBuffer, 2)
   end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var Timer1_Test : integer;
begin
  Timer1_Test := HID_DeviceTest(62703, 43904, 2, 0) ;
  if  Timer1_Test <> Old_Timer1_Test then  begin
    Old_Timer1_Test := Timer1_Test ;
    if Timer1_Test = 1 then  begin
       HID_CloseDevice(W_Handle);
       W_Handle := HID_OpenDevice(62703, 43904, 2, 0) ;
       Label1.Caption := ' ';
    end else begin
       HID_CloseDevice(W_Handle);
       W_Handle := 0  ;
       Label1.Caption := '  ';
       label2.Caption := ' = 0';
    end;
  end;
end;



procedure TForm1.FormCreate(Sender: TObject);
 var  NewThread: TNewThread;
begin
  NewThread:=TNewThread.Create(true);
  NewThread.FreeOnTerminate:=true;
  NewThread.Priority:=tpLower;
  NewThread.Resume;
end;




end.



