﻿Public Class Form1

    Public Declare Function HID_OpenDevice Lib "HID_Lib_Plus.dll" (ByVal PID As Integer, ByVal VID As Integer, ByVal VersionNumber As Short, ByVal Index As Short) As Integer
    Public Declare Function HID_CloseDevice Lib "HID_Lib_Plus.dll" (ByVal Handle As Integer) As Integer
    Public Declare Function HID_ReadDevice Lib "HID_Lib_Plus.dll" (ByVal Handle As Integer, ByVal buffer() As Byte, ByVal Len As Integer) As Integer
    Public Declare Function HID_WriteDevice Lib "HID_Lib_Plus.dll" (ByVal Handle As Integer, ByVal buffer() As Byte, ByVal Len As Integer) As Integer
    Public Declare Function HID_DeviceTest Lib "HID_Lib_Plus.dll" (ByVal PID As Integer, ByVal VID As Integer, ByVal VersionNumber As Short, ByVal Index As Short) As Integer

    Dim vid As Integer = &HAB80
    Dim pid As Integer = &HF4EF
    Dim R_Handle, W_Handle As Integer
    Dim Old_Test As Integer

    Dim thread1 As New System.Threading.Thread(AddressOf threadProc)



    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        thread1.IsBackground = True
        thread1.Start()
    End Sub


    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim Test As Integer

        Test = HID_DeviceTest(pid, vid, 2, 0)
        If Test <> Old_Test Then
            Old_Test = Test
            If Test <> 0 Then
                R_Handle = HID_OpenDevice(pid, vid, 2, 0)
                W_Handle = HID_OpenDevice(pid, vid, 2, 0)
                Label1.Text = "Устройство подключено"
            Else
                HID_CloseDevice(R_Handle) : R_Handle = 0
                HID_CloseDevice(W_Handle) : W_Handle = 0
                Label1.Text = "Устройство не найденно"
                Label2.Text = "Кнопка = 0"
            End If
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim OutBuffer(1) As Byte
        If W_Handle <> 0 Then
            OutBuffer(0) = 0 ' Идентификатор репорта
            OutBuffer(1) = 1 ' Команда "Зажечь светодиод"
            HID_WriteDevice(W_Handle, OutBuffer, OutBuffer.Length)
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim OutBuffer(1) As Byte
        If W_Handle <> 0 Then
            OutBuffer(0) = 0 ' Идентификатор репорта
            OutBuffer(1) = 0 ' Команда "Погасить светодиод"
            HID_WriteDevice(W_Handle, OutBuffer, OutBuffer.Length)
        End If
    End Sub

    Delegate Sub SetTextLabel2_(ByVal InByte As Byte)
    Private Sub SetTextLabel2(ByVal InByte As Byte)
        If Label2.InvokeRequired Then
            Label2.Invoke(New SetTextLabel2_(AddressOf SetTextLabel2), InByte)
        Else
            Label2.Text = "Кнопка = " & InByte
        End If
    End Sub

    Private Sub threadProc()
        Dim InBuffer(1) As Byte
        Do
            If R_Handle <> 0 Then
                InBuffer(0) = 0 ' ID репорта
                If HID_ReadDevice(R_Handle, InBuffer, InBuffer.Length) = InBuffer.Length Then
                    'Label2.Text = "Кнопка = " & InBuffer(1)
                    If InBuffer(1) = 1 Then
                        SetTextLabel2(0)
                    Else
                        SetTextLabel2(1)
                    End If
                End If
            End If
            System.Threading.Thread.Sleep(10)
        Loop
    End Sub
End Class
