;       PicKit 2  microchip.
;   ,        .

#USB_PID          = $33      ;   PicKit 2
#USB_VID          = $4D8
#PK_PACKET_SIZE   =  65


If OpenLibrary(1,"HID_Lib_Plus_x64.dll")=0
 MessageRequester("", "  "+Chr(34)+"HID_Lib_Plus_x64.dll"+Chr(34), 16)
 End
EndIf

Prototype HID_OpenDevice(PID.w, VID.w, Number.w, Index.w)
 Global HID_OpenDevice.HID_OpenDevice=GetFunction(1,"HID_OpenDevice")
Prototype HID_WriteDevice(Handle, *Buffer, LenBuf)
 Global HID_WriteDevice.HID_WriteDevice=GetFunction(1,"HID_WriteDevice")
Prototype HID_CloseDevice(Handle)
 Global HID_CloseDevice.HID_CloseDevice=GetFunction(1,"HID_CloseDevice")

Procedure VddOn(Handle) ;  
 Dim OutBuffer.b(#PK_PACKET_SIZE+2)
 OutBuffer(0)=0
 OutBuffer(1)=$A6 ; EXECUTE_SCRIPT
 OutBuffer(2)=2
 OutBuffer(3)=$FC ; _VDD_GND_OFF
 OutBuffer(4)=$FF ; _VDD_ON
ProcedureReturn HID_WriteDevice(Handle, @OutBuffer(), #PK_PACKET_SIZE)
EndProcedure

Procedure VddOff(Handle) ;  
 Dim OutBuffer.b(#PK_PACKET_SIZE+2)
 OutBuffer(0)=0
 OutBuffer(1)=$A6 ; EXECUTE_SCRIPT
 OutBuffer(2)=2
 OutBuffer(3)=$FE ; _VDD_OFF
 OutBuffer(4)=$FD ; _VDD_GND_ON
ProcedureReturn HID_WriteDevice(Handle, @OutBuffer(), #PK_PACKET_SIZE)
EndProcedure


Handle=HID_OpenDevice(#USB_PID, #USB_VID, -1, 0) ;    PicKit 2
 If Handle
   VddOn(Handle)                           ;    
   Delay(1000)                             ; ,  1000 
   VddOff(Handle)                          ;    
   HID_CloseDevice(Handle)                 ;    PicKit 2
 Else
   MessageRequester("PicKit 2 Test", "   PicKit2!", #MB_OK|#MB_ICONWARNING)
 EndIf
; IDE Options = PureBasic 4.31 (Windows - x64)
; CursorPosition = 7
; Folding = -
; EnableXP
; UseIcon = icon.ico
; Executable = PicKit2_Test.exe