; ,   ,    "" 2010,  3, . 25-28

Enumeration ;- Window Constants
  #Window_0
EndEnumeration

Enumeration ;- Gadget Constants
  #Text_NoDevice
  #Text_Button_White
  #Text_Button_Black
  #Button_Yellow_LED
  #Button_Green_LED
  #Button_All_LED
EndEnumeration


#USB_PID          = $104      ;  HID 
#USB_VID          = $2009

Global R_Handle, W_Handle ;   (  )

If OpenLibrary(1,"HID_Lib_Plus.dll")=0
 MessageRequester("", "  "+Chr(34)+"HID_Lib_Plus.dll"+Chr(34), 16)
 End
EndIf

Prototype HID_DeviceTest(PID.w, VID.w, Number.w, Index.w)
 Global HID_DeviceTest.HID_DeviceTest=GetFunction(1,"HID_DeviceTest")
Prototype HID_OpenDevice(PID.w, VID.w, Number.w, Index.w)
 Global HID_OpenDevice.HID_OpenDevice=GetFunction(1,"HID_OpenDevice")
Prototype HID_ReadDevice(Handle, *Buffer, LenBuf)
 Global HID_ReadDevice.HID_ReadDevice=GetFunction(1,"HID_ReadDevice")
Prototype HID_WriteDevice(Handle, *Buffer, LenBuf)
 Global HID_WriteDevice.HID_WriteDevice=GetFunction(1,"HID_WriteDevice")
Prototype HID_CloseDevice(Handle)
 Global HID_CloseDevice.HID_CloseDevice=GetFunction(1,"HID_CloseDevice")
 
Procedure MessageNoDevice()
  MessageRequester("USB_HID","    !",16)
EndProcedure

;    
Procedure Yellow_LED()
 Dim OutBuf.a(10)
 If W_Handle
   OutBuf(0)=$77 ;   HID  REPORT_ID = 0x77
   OutBuf(1)=$AA
   OutBuf(2)=$55
   HID_WriteDevice(W_Handle, @OutBuf(), 9)
   
   For i=1 To 10
     WindowEvent()
     Delay(50)
   Next i
   
   OutBuf(1)=0
   OutBuf(2)=0
   HID_WriteDevice(W_Handle, @OutBuf(), 9)
 Else
   MessageNoDevice()
 EndIf
EndProcedure

;    
Procedure Green_LED()
 Dim OutBuf.a(10)
 If W_Handle
   OutBuf(0)=$77 ;   HID  REPORT_ID = 0x77
   OutBuf(3)=$55
   OutBuf(4)=$AA
   HID_WriteDevice(W_Handle, @OutBuf(), 9)
   
   For i=1 To 10
     WindowEvent()
     Delay(50)
   Next i
   
   OutBuf(3)=0
   OutBuf(4)=0
   HID_WriteDevice(W_Handle, @OutBuf(), 9)
 Else
   MessageNoDevice()
 EndIf
EndProcedure

;    
Procedure All_LED()
 Dim OutBuf.a(10)
 If W_Handle
   OutBuf(0)=$77 ;   HID  REPORT_ID = 0x77
   OutBuf(1)=$AA
   OutBuf(2)=$55
   OutBuf(3)=$55
   OutBuf(4)=$AA
 HID_WriteDevice(W_Handle, @OutBuf(), 9)
 Else
   MessageNoDevice()
 EndIf
EndProcedure

;   HID . 
;      .
Procedure ReadDevice_Thread(*xx)
 Dim InBuf.a(10)
 Button_White=0  ;   
 Button_Black=0  ;  ׸ 
 
 Repeat
 
   If R_Handle
     InBuf(0)=$77      ;   HID  REPORT_ID = 0x77
     If HID_ReadDevice(R_Handle, @InBuf(), 4)
        
         If InBuf(1)<>Button_White
             Button_White=InBuf(1)
             If Button_White
               Color=$0004F0
             Else
               Color=$FF0000
             EndIf
             SetGadgetColor(#Text_Button_White, #PB_Gadget_FrontColor, Color)
             SetGadgetText(#Text_Button_White, "  = "+Str(Button_White))
         EndIf
         
         If InBuf(2)<>Button_Black
             Button_Black=InBuf(2)
             If Button_Black
               Color=$0004F0
             Else
               Color=$FF0000
             EndIf
             SetGadgetColor(#Text_Button_Black, #PB_Gadget_FrontColor, Color)
             SetGadgetText(#Text_Button_Black, "׸  = "+Str(Button_Black))
         EndIf
      
     EndIf
   Else
     Delay(200)
     Button_White=0
     Button_Black=0
   EndIf
   
 ForEver
 
EndProcedure

;  HID    ( 400 .)
Procedure FindDevice_Timer()
Static Old_Test
 Test=HID_DeviceTest(#USB_PID, #USB_VID, -1 ,0)
 If Test<>Old_Test
   Old_Test=Test 
   If Test 
      HID_CloseDevice(R_Handle) : HID_CloseDevice(W_Handle)
      W_Handle=HID_OpenDevice(#USB_PID, #USB_VID, -1 ,0)
      R_Handle=HID_OpenDevice(#USB_PID, #USB_VID, -1, 0)
      
      SetGadgetText(#Text_Button_White, "  = 0")
      SetGadgetText(#Text_Button_Black, "׸  = 0")
      SetGadgetColor(#Text_Button_White, #PB_Gadget_FrontColor, RGB(0, 0, 250) )
      SetGadgetColor(#Text_Button_Black, #PB_Gadget_FrontColor, RGB(0, 0, 250) )
      HideGadget(#Text_NoDevice, #True)
      HideGadget(#Text_Button_White, #False) :  HideGadget(#Text_Button_Black, #False)
   Else
      HID_CloseDevice(R_Handle) : R_Handle=0
      HID_CloseDevice(W_Handle) : W_Handle=0
      HideGadget(#Text_Button_White, #True) :  HideGadget(#Text_Button_Black, #True)
      HideGadget(#Text_NoDevice, #False)
   EndIf
 EndIf
EndProcedure


Procedure Open_Window_0()
 If OpenWindow(#Window_0, 0, 0, 300, 100, Chr(34)+""+Chr(34)+" 2010,  3, . 25-28", #PB_Window_MinimizeGadget | #PB_Window_Invisible | #PB_Window_ScreenCentered)
   TextGadget(#Text_NoDevice, 5, 10, 290, 16, "USB     ", #PB_Text_Center)
     SetGadgetColor(#Text_NoDevice,#PB_Gadget_FrontColor, RGB(129, 2, 126) )
   TextGadget(#Text_Button_White,20,10,120,16,"  = 0")    : HideGadget(#Text_Button_White, #True)
     SetGadgetColor(#Text_Button_White, #PB_Gadget_FrontColor, RGB(0, 0, 250) )
   TextGadget(#Text_Button_Black, 170,10,120,16,"׸  = 0") : HideGadget(#Text_Button_Black, #True)
     SetGadgetColor(#Text_Button_Black, #PB_Gadget_FrontColor, RGB(0, 0, 250) )
   ButtonGadget(#Button_Yellow_LED, 10, 30, 120, 28, "Ƹ ")
   ButtonGadget(#Button_Green_LED, 160, 30, 130, 28, " ")
   ButtonGadget(#Button_All_LED, 95, 65, 105, 28, " ")
 EndIf
EndProcedure

Open_Window_0()
FindDevice_Timer()
AddWindowTimer(#Window_0, 1, 400)
ThreadID=CreateThread(@ReadDevice_Thread(), 0)

HideWindow(#Window_0, #False)

Repeat
   Event=WaitWindowEvent()
   If Event=#PB_Event_Timer
     If EventTimer()=1
       FindDevice_Timer()
     EndIf
   
   ElseIf Event=#PB_Event_Gadget
     Select EventGadget()
       Case #Button_Yellow_LED
         Yellow_LED()
       Case #Button_Green_LED
         Green_LED()
       Case #Button_All_LED
         All_LED()
     EndSelect 
   EndIf
Until Event=#PB_Event_CloseWindow

KillThread(ThreadID)
; IDE Options = PureBasic 4.41 (Windows - x86)
; CursorPosition = 31
; FirstLine = 15
; Folding = --
; EnableThread
; EnableXP
; UseIcon = .ico
; Executable = USB_HID.exe