﻿ 
   Structure HID_Sub_DeviceInfo
     VendorID.w
     ProductID.w
     VersionNumber.w
     NumInputBuffers.w
     InputReportByteLength.w
     OutputReportByteLength.w
     FeatureReportByteLength.w
     Manufacturer.s
     Product.s
     SerialNumber.s
   EndStructure

   Structure HID_DeviceInfo
     CountDevice.w              ; Число обнаруженных HID устройств
     DeviceInfo.HID_Sub_DeviceInfo[258] ; Статический массив структур "HID_Sub_DeviceInfo"
   EndStructure

  Info.HID_DeviceInfo
  
  
If OpenLibrary(1,"HID_Lib_Plus_Unicode.dll")=0
 MessageRequester("", "Отсутствует файл "+Chr(34)+"HID_Lib_Plus_Unicode.dll"+Chr(34), 16)
 End
EndIf

Prototype DeviceInfo(*Point)
Global HID_DeviceInfo.DeviceInfo=GetFunction(1,"HID_DeviceInfo")

Procedure DevInfo()
Shared Info
ClearGadgetItems(0)
If HID_DeviceInfo(@Info)
  If Info\CountDevice>0
    For i=0 To Info\CountDevice - 1 
      AddGadgetItem(0,i,Info\DeviceInfo[i]\Manufacturer)
      SetGadgetItemText(0,i,Info\DeviceInfo[i]\Product,1)
      SetGadgetItemText(0,i,Hex(Info\DeviceInfo[i]\ProductID,#PB_Word)+"H",2)
      SetGadgetItemText(0,i,Hex(Info\DeviceInfo[i]\VendorID,#PB_Word)+"H",3)
      SetGadgetItemText(0,i,Hex(Info\DeviceInfo[i]\VersionNumber,#PB_Word)+"H",4)
      SetGadgetItemText(0,i,Info\DeviceInfo[i]\SerialNumber,5)
      SetGadgetItemText(0,i,Str(Info\DeviceInfo[i]\NumInputBuffers),6)
      SetGadgetItemText(0,i,Str(Info\DeviceInfo[i]\InputReportByteLength),7)
      SetGadgetItemText(0,i,Str(Info\DeviceInfo[i]\OutputReportByteLength),8)
      SetGadgetItemText(0,i,Str(Info\DeviceInfo[i]\FeatureReportByteLength),9)
    Next i
  EndIf
EndIf
EndProcedure


OpenWindow(0,0,0,930,294,"Иформация о USB HID устройствах     —     HID_DeviceInfo",#PB_Window_MinimizeGadget|#PB_Window_Invisible|#PB_Window_ScreenCentered)
 ListIconGadget(0,2,2,924,290,"Изготовитель",100,#PB_ListIcon_GridLines|#PB_ListIcon_FullRowSelect|#PB_ListIcon_HeaderDragDrop)
   AddGadgetColumn(0,1,"Продукт",100)
   AddGadgetColumn(0,2,"PID",48)
   AddGadgetColumn(0,3,"VID",48)
   AddGadgetColumn(0,4,"Номер версии",90)
   AddGadgetColumn(0,5,"Серийный номер",104)
   AddGadgetColumn(0,6,"Число вх. буферов",110)
   AddGadgetColumn(0,7,"Размер вх. репорта",120)
   AddGadgetColumn(0,8,"Размер вых. репорта",124)
   AddGadgetColumn(0,9,"FEATURE",70)
DevInfo()
HideWindow(0,0)

AddWindowTimer(0, 1, 400)

Repeat
   Event=WaitWindowEvent()
   If Event=#PB_Event_Timer
     If  EventTimer()=1
       DevInfo()
     EndIf
   EndIf
Until Event = #PB_Event_CloseWindow


; IDE Options = PureBasic 4.41 (Windows - x86)
; CursorPosition = 23
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = .ico
; Executable = HID_Info_Unicode.exe