﻿; Этот пример демонстрирует работу с программатором PicKit 2 фирмы microchip.
; После его запуска, на секунду будет подано питание на программируемый микроконтроллер.

#USB_PID          = $33      ; Идентификаторы программатора PicKit 2
#USB_VID          = $4D8
#PK_PACKET_SIZE   =  65

If OpenLibrary(1,"HID_Lib_Plus_Unicode.dll")=0
 MessageRequester("", "Отсутствует файл "+Chr(34)+"HID_Lib_Plus_Unicode.dll"+Chr(34), 16)
 End
EndIf

Prototype HID_OpenDevice(PID.w, VID.w, Number.w, Index.w)
 Global HID_OpenDevice.HID_OpenDevice=GetFunction(1,"HID_OpenDevice")
Prototype HID_WriteDevice(Handle, *Buffer, LenBuf)
 Global HID_WriteDevice.HID_WriteDevice=GetFunction(1,"HID_WriteDevice")
Prototype HID_CloseDevice(Handle)
 Global HID_CloseDevice.HID_CloseDevice=GetFunction(1,"HID_CloseDevice")

Procedure VddOn(Handle) ; Включить питание
 Dim OutBuffer.b(#PK_PACKET_SIZE+2)
 OutBuffer(0)=0
 OutBuffer(1)=$A6 ; EXECUTE_SCRIPT
 OutBuffer(2)=2
 OutBuffer(3)=$FC ; _VDD_GND_OFF
 OutBuffer(4)=$FF ; _VDD_ON
ProcedureReturn HID_WriteDevice(Handle, @OutBuffer(), #PK_PACKET_SIZE)
EndProcedure

Procedure VddOff(Handle) ; Выключить питание
 Dim OutBuffer.b(#PK_PACKET_SIZE+2)
 OutBuffer(0)=0
 OutBuffer(1)=$A6 ; EXECUTE_SCRIPT
 OutBuffer(2)=2
 OutBuffer(3)=$FE ; _VDD_OFF
 OutBuffer(4)=$FD ; _VDD_GND_ON
ProcedureReturn HID_WriteDevice(Handle, @OutBuffer(), #PK_PACKET_SIZE)
EndProcedure

Handle=HID_OpenDevice(#USB_PID, #USB_VID, -1, 0) ; Установка связи с PicKit 2
 If Handle
   VddOn(Handle)                           ; Включить питание программируемого МК
   Delay(1000)                             ; Пауза, равная 1000 миллисекунд
   VddOff(Handle)                          ; Выключить питание программируемого МК
   HID_CloseDevice(Handle)                 ; Разыв связи с PicKit 2
 Else
   MessageRequester("PicKit 2 Test", "Нет связи с PicKit2!", 48)
 EndIf
; IDE Options = PureBasic 4.41 (Windows - x86)
; CursorPosition = 46
; FirstLine = 8
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = .ico
; Executable = PicKit2_Test_Unicode.exe